Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-SP6_BLUEFIRE.README
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-SP6_BLUEFIRE.README	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-SP6_BLUEFIRE.README	(revision 221)
@@ -0,0 +1,16 @@
+# To setup environment variables on NCAR Bluefire SP6
+# Change your shell to bash : 
+# see http://www2.cisl.ucar.edu/docs/bluefire/getting-started
+# tab 'Shell and environment'
+# then put the following lines in your ~/.profile
+
+. /contrib/Modules/3.2.6/init/bash
+module load emacs
+module load netcdf
+module load svn-1.5
+
+export TERM=xterm
+export PATH=${HOME}/bin:/usr/local/bin/:$PATH
+
+# NB : The above PATH lets FCM find GNU make and GNU cpp
+# which are in /usr/local/bin. 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-SP6_BLUEFIRE.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-SP6_BLUEFIRE.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-SP6_BLUEFIRE.fcm	(revision 221)
@@ -0,0 +1,15 @@
+%COMPILER            xlf
+%LINK                xlf
+%AR                  ar
+%MAKE                /usr/local/bin/gmake
+%FPP_FLAGS           
+%FPP_DEF             
+%BASE_FFLAGS         -qlanglvl=2003pure -u -qintsize=4 -qrealsize=8
+%PROD_FFLAGS         -O3
+%DEV_FFLAGS          -p -g -O3 -traceback -fp-stack-check -ftrapuv
+%DEBUG_FFLAGS        -p -g -traceback
+%MPI_FFLAGS
+%OMP_FFLAGS          
+%BASE_LD             -qintsize=4 -qrealsize=8
+%MPI_LD
+%OMP_LD
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-SP6_BLUEFIRE.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-SP6_BLUEFIRE.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-SP6_BLUEFIRE.path	(revision 221)
@@ -0,0 +1,10 @@
+NETCDF_LIBDIR="-L$LIB_NETCDF -lnetcdff"
+NETCDF_INCDIR="-I$NETCDF/include"
+IOIPSL_INCDIR=$LMDGCM/../../lib
+IOIPSL_LIBDIR=$LMDGCM/../../lib
+ORCH_INCDIR=$LMDGCM/../../lib
+ORCH_LIBDIR=$LMDGCM/../../lib
+OASIS_INCDIR=$LMDGCM/../../prism/X64/build/lib/psmile.$couple
+OASIS_LIBDIR=$LMDGCM/../../prism/X64/lib
+INCA_LIBDIR=$LMDGCM/../INCA3/config/lib
+INCA_INCDIR=$LMDGCM/../INCA3/config/lib
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_ADA.env
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_ADA.env	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_ADA.env	(revision 221)
@@ -0,0 +1,6 @@
+module unload compilerwrappers
+module unload netcdf
+module unload hdf5
+
+module load netcdf
+module load hdf5
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_ADA.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_ADA.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_ADA.fcm	(revision 221)
@@ -0,0 +1,16 @@
+%COMPILER            mpiifort
+%LINK                mpiifort
+%FPP                 mpiifort -E
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P
+%FPP_DEF             KEY_NONE CPP_NETCDF4
+%BASE_FFLAGS         -i4 -r8 -auto -align all -I${MKLROOT}/include
+%PROD_FFLAGS         -g -traceback -O3 -vec-report2
+%DEV_FFLAGS          -g -O1 -traceback
+%DEBUG_FFLAGS        -g -traceback -check bounds -fp-model strict
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp
+%BASE_LD             -i4 -r8 -auto ${MKL_LIBS}
+%MPI_LD
+%OMP_LD              -openmp
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_ADA.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_ADA.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_ADA.path	(revision 221)
@@ -0,0 +1,11 @@
+#NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+#NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+#NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+#HDF5_INCDIR="-I $HDF5_INC_DIR"
+#HDF5_LIBDIR="-L $HDF5_LIB_DIR"
+#HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE.env
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE.env	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE.env	(revision 221)
@@ -0,0 +1,12 @@
+module unload netcdf
+module unload hdf5
+module load netcdf/4.2_hdf5_parallel
+module load  hdf5/1.8.9_parallel
+module load vampir
+module load vampirtrace
+
+#export HDF5_INC_DIR=$WORKDIR/hdf5/include
+#export HDF5_LIB_DIR=$WORKDIR/hdf5/lib
+
+#export NETCDF_INC_DIR=$WORKDIR/netcdf4/include
+#export NETCDF_LIB_DIR=$WORKDIR/netcdf4/lib
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE.fcm	(revision 221)
@@ -0,0 +1,16 @@
+%COMPILER            mpif90 
+%LINK                mpif90 
+%FPP                 mpif90 -E
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P
+%FPP_DEF             KEY_NONE CPP_NETCDF4
+%BASE_FFLAGS         -i4 -r8 -auto -align all -I${MKLROOT}/include
+%PROD_FFLAGS         -g -traceback -O3 -vec-report2 -xAVX
+%DEV_FFLAGS          -g -O1 -traceback
+%DEBUG_FFLAGS        -g -traceback -check stack -check bounds -fp-model strict
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp -openmp-threadprivate compat
+%BASE_LD             -i4 -r8 -auto $MKL_LIBS -L../../LMDZ.COMMON/lib -llmdz
+%MPI_LD
+%OMP_LD              -openmp
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE.path	(revision 221)
@@ -0,0 +1,15 @@
+NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+NETCDF_LIBDIR="-Wl,-rpath=$NETCDF_LIB_DIR -L$NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-Wl,-rpath=$HDF5_LIB_DIR -L$HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
+
+XIOS_INCDIR="-I$WORKDIR/XIOS_COMMIT_V1.7/inc"
+XIOS_LIBDIR="-L$WORKDIR/XIOS_COMMIT_V1.7/lib"
+XIOS_LIB="-lxios -lstdc++"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE_VAMPIR.env
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE_VAMPIR.env	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE_VAMPIR.env	(revision 221)
@@ -0,0 +1,14 @@
+module unload netcdf
+module unload hdf5
+module load netcdf/4.2_hdf5_parallel
+module load  hdf5/1.8.9_parallel
+module unload vampir
+module unload vampirtrace
+module load vampir
+module load vampirtrace
+
+#export HDF5_INC_DIR=$WORKDIR/hdf5/include
+#export HDF5_LIB_DIR=$WORKDIR/hdf5/lib
+
+#export NETCDF_INC_DIR=$WORKDIR/netcdf4/include
+#export NETCDF_LIB_DIR=$WORKDIR/netcdf4/lib
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE_VAMPIR.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE_VAMPIR.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE_VAMPIR.fcm	(revision 221)
@@ -0,0 +1,23 @@
+%COMPILER            vtf90 -vt:f90 "mpif90 -openmp -openmp-threadprivate compat -fno-instrument-functions " -vt:noopari -vt:inst manual -DVTRACE
+%LINK                vtf90 -vt:f90 "mpif90 -openmp -openmp-threadprivate compat -fno-instrument-functions" -vt:noopari -vt:inst manual -DVTRACE 
+%FPP                 vtf90 -vt:f90 "mpif90 -E  -fno-instrument-functions" -vt:noopari -vt:inst manual -DVTRACE
+#%COMPILER            vtf90 -vt:f90 "mpif90 " -vt:inst manual -DVTRACE
+#%LINK                vtf90 -vt:f90 "mpif90" -vt:inst manual -DVTRACE 
+#%FPP                 vtf90 -vt:f90 "mpif90 -E" -vt:inst manual -DVTRACE
+#%COMPILER           ifort
+#%LINK               ifort 
+#%FPP                ifort -E
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P
+%FPP_DEF             KEY_NONE VTRACE CPP_NETCDF4
+#%FPP_DEF             KEY_NONE CPP_NETCDF4
+%BASE_FFLAGS         -i4 -r8 -auto -align all -I${MKLROOT}/include
+%PROD_FFLAGS         -p -g -traceback -O3 -vec-report2 -xAVX 
+%DEV_FFLAGS          -g -O3 -traceback -fp-stack-check -ftrapuv
+%DEBUG_FFLAGS        -g  -fp-model strict -traceback -check bounds
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp
+%BASE_LD             -i4 -r8 -auto $MKL_LIBS
+%MPI_LD
+%OMP_LD              -openmp
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE_VAMPIR.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE_VAMPIR.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_CURIE_VAMPIR.path	(revision 221)
@@ -0,0 +1,15 @@
+NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+NETCDF_LIBDIR="-Wl,-rpath=$NETCDF_LIB_DIR -L$NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-Wl,-rpath=$HDF5_LIB_DIR -L$HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
+
+XIOS_INCDIR="-I$WORKDIR/XIOS_COMMIT_V1.7/inc"
+XIOS_LIBDIR="-L$WORKDIR/XIOS_COMMIT_V1.7/lib"
+XIOS_LIB="-lxios -lstdc++"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_HORUS.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_HORUS.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_HORUS.fcm	(revision 221)
@@ -0,0 +1,15 @@
+%COMPILER            mpif90
+%LINK                mpif90
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE CPP_NETCDF4
+%BASE_FFLAGS         -fdefault-real-8
+%PROD_FFLAGS         -O3 
+%DEV_FFLAGS          -p -g -O 
+%DEBUG_FFLAGS        -p -g  -fbacktrace -fbounds-check
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp
+%BASE_LD             -p 
+%OMP_LD              -openmp
+%OMP_LD              -openmp
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_HORUS.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_HORUS.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_HORUS.path	(revision 221)
@@ -0,0 +1,3 @@
+NETCDF_LIBDIR='-L/usr/local/lib -lnetcdff'
+NETCDF_INCDIR=-I/usr/local/include
+
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_LYNX.env
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_LYNX.env	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_LYNX.env	(revision 221)
@@ -0,0 +1,4 @@
+module unload PrgEnv-pgi
+module load PrgEnv-intel
+
+module load netcdf
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_LYNX.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_LYNX.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_LYNX.fcm	(revision 221)
@@ -0,0 +1,15 @@
+%COMPILER            ftn 
+%LINK                ftn 
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE CPP_NETCDF4
+%BASE_FFLAGS         -i4 -r8 -automatic -align all
+%PROD_FFLAGS         -O3
+%DEV_FFLAGS          -p -g -O3 -traceback -fp-stack-check -ftrapuv
+%DEBUG_FFLAGS        -p -g -traceback -check bounds
+%MPI_FFLAGS
+%OMP_FFLAGS          
+%BASE_LD              -i4 -r8 -automatic
+%MPI_LD
+%OMP_LD              
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_LYNX.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_LYNX.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_LYNX.path	(revision 221)
@@ -0,0 +1,11 @@
+NETCDF_INCDIR="-I$CRAY_NETCDF_DIR/include"
+NETCDF_LIBDIR="-L$CRAY_NETCDF_DIR/lib"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR=""
+HDF5_LIBDIR=""
+HDF5_LIB=""
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_MIRAGE.env
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_MIRAGE.env	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_MIRAGE.env	(revision 221)
@@ -0,0 +1,10 @@
+#module unload netcdf
+#module unload hdf5
+#module load netcdf/3.6.3
+"module load hdf5
+
+export HDF5_INC_DIR=$WORKDIR/hdf5/include
+export HDF5_LIB_DIR=$WORKDIR/hdf5/lib
+
+export NETCDF_INC_DIR=/fs/local/apps/netcdf-4.1.3_intel/include 
+export NETCDF_LIB_DIR=/fs/local/apps/netcdf-4.1.3_intel/lib
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_MIRAGE.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_MIRAGE.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_MIRAGE.fcm	(revision 221)
@@ -0,0 +1,15 @@
+%COMPILER            ifort 
+%LINK                ifort 
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE CPP_NETCDF4
+%BASE_FFLAGS         -i4 -r8 -automatic -align all
+%PROD_FFLAGS         -O3
+%DEV_FFLAGS          -p -g -O3 -traceback -fp-stack-check -ftrapuv
+%DEBUG_FFLAGS        -p -g -traceback -check bounds
+%MPI_FFLAGS
+%OMP_FFLAGS          
+%BASE_LD              -i4 -r8 -automatic
+%MPI_LD
+%OMP_LD              
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_MIRAGE.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_MIRAGE.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_MIRAGE.path	(revision 221)
@@ -0,0 +1,11 @@
+NETCDF_INCDIR="-I/fs/local/apps/netcdf-4.1.3_intel/include"
+NETCDF_LIBDIR="-L/fs/local/apps/netcdf-4.1.3_intel/lib"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR=""
+HDF5_LIBDIR=""
+HDF5_LIB=""
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_OSX.README
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_OSX.README	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_OSX.README	(revision 221)
@@ -0,0 +1,12 @@
+# MacPorts environment :
+# sudo port install gcc45
+# sudo port select gcc mp-gcc45
+# sudo port install netcdf-fortran +gcc45
+
+# for VTKMapper
+# sudo port install python27
+# sudo port select python python27
+# sudo port install vtk5 +python27
+# sudo port install hdf5-18 +gcc45
+# compile python->NetCDF interface netCDF4-0.9.3
+#      sudo python setup.py install
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_OSX.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_OSX.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_OSX.fcm	(revision 221)
@@ -0,0 +1,16 @@
+%COMPILER            gfortran
+%LINK                gfortran
+%AR                  ar
+%MAKE                gmake
+%FPP                 gfortran -E
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE CPP_NETCDF4
+%BASE_FFLAGS         -I /opt/local/include -fdefault-real-8 -ffree-line-length-none
+%PROD_FFLAGS         -O3 
+%DEV_FFLAGS          -p -g -O 
+%DEBUG_FFLAGS        -p -g  -fbacktrace -fbounds-check
+%MPI_FFLAGS
+%OMP_FFLAGS          
+%BASE_LD             -p -L/opt/local/lib  -lnetcdff -lnetcdf
+%OMP_LD              
+%OMP_LD              
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_OSX.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_OSX.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_OSX.path	(revision 221)
@@ -0,0 +1,11 @@
+NETCDF_LIBDIR=
+NETCDF_INCDIR=
+IOIPSL_INCDIR=$LMDGCM/../IOIPSL/src/
+IOIPSL_LIBDIR=$LMDGCM/../IOIPSL/src/
+ORCH_INCDIR=/work/cont003/p86yann/ORCHIDEE_1_9_2_OMP_MEM/lib_cpl
+ORCH_LIBDIR=/work/cont003/p86yann/ORCHIDEE_1_9_2_OMP_MEM/lib_cpl
+OASIS_INCDIR=$LMDGCM/../../prism/IA64/build/lib/psmile.$couple
+OASIS_LIBDIR=$LMDGCM/../../prism/IA64/lib
+INCA_LIBDIR=$LMDGCM/../INCA3/config/lib
+INCA_INCDIR=$LMDGCM/../INCA3/config/lib
+
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE.env
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE.env	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE.env	(revision 221)
@@ -0,0 +1,10 @@
+module unload netcdf
+module unload hdf5
+module load netcdf/3.6.3
+module load hdf5
+
+#export HDF5_INC_DIR=$WORKDIR/hdf5/include
+#export HDF5_LIB_DIR=$WORKDIR/hdf5/lib
+
+#export NETCDF_INC_DIR=$WORKDIR/netcdf4/include
+#export NETCDF_LIB_DIR=$WORKDIR/netcdf4/lib
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE.fcm	(revision 221)
@@ -0,0 +1,15 @@
+%COMPILER            mpif90
+%LINK                mpif90
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE 
+%BASE_FFLAGS         -i4 -r8 -automatic -align all -I${MKLROOT}/include
+%PROD_FFLAGS         -O3 -openmp
+%DEV_FFLAGS          -p -g -O3 -traceback -fp-stack-check -ftrapuv
+%DEBUG_FFLAGS        -p -g -traceback -check bounds
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp
+%BASE_LD             -openmp -i4 -r8 -automatic $MKL_LIBS
+%MPI_LD
+%OMP_LD              -openmp
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE.path	(revision 221)
@@ -0,0 +1,11 @@
+NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-L $HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE_SEQ.env
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE_SEQ.env	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE_SEQ.env	(revision 221)
@@ -0,0 +1,4 @@
+module unload netcdf
+module unload hdf5
+module load netcdf/3.6.3
+module load hdf5
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE_SEQ.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE_SEQ.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE_SEQ.fcm	(revision 221)
@@ -0,0 +1,15 @@
+%COMPILER            ifort
+%LINK                ifort
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE 
+%BASE_FFLAGS         -i4 -r8 -automatic -align all -I${MKLROOT}/include
+%PROD_FFLAGS         -O3 -openmp
+%DEV_FFLAGS          -p -g -O3 -traceback -fp-stack-check -ftrapuv
+%DEBUG_FFLAGS        -p -g -traceback -check bounds
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp
+%BASE_LD             -openmp -i4 -r8 -automatic $MKL_LIBS
+%MPI_LD
+%OMP_LD              -openmp
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE_SEQ.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE_SEQ.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-X64_TITANE_SEQ.path	(revision 221)
@@ -0,0 +1,11 @@
+NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-L $HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skd.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skd.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skd.fcm	(revision 221)
@@ -0,0 +1,15 @@
+%COMPILER            gfortran 
+%LINK                gfortran
+%AR                  ar
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE
+%BASE_FFLAGS         -I/home/sarvesh/LMDZS/netcdf-4.0.1/include -fdefault-real-8
+%PROD_FFLAGS         -O3 
+%DEV_FFLAGS          -p -g -O 
+%DEBUG_FFLAGS        -p -g  -fbacktrace -fbounds-check
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp
+%BASE_LD             -p  -L/home/sarvesh/LMDZS/netcdf-4.0.1/lib  -lnetcdf  -lblas -llapack
+%MPI_LD             
+%OMP_LD              -openmp
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skd.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skd.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skd.path	(revision 221)
@@ -0,0 +1,9 @@
+#NETCDF_LIBDIR='/usr/lib -lnetcdf'
+#NETCDF_INCDIR='/usr/include'
+NETCDF_LIBDIR="-L /home/sarvesh/LMDZS/netcdf-4.0.1/lib"
+NETCDF_INCDIR="-I /home/sarvesh/LMDZS/netcdf-4.0.1/include"
+NETCDF_LIB="-lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skdmpi.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skdmpi.fcm	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skdmpi.fcm	(revision 221)
@@ -0,0 +1,15 @@
+%COMPILER            mpif90 
+%LINK                mpif90
+%AR                  ar
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE
+%BASE_FFLAGS         -I/home/sarvesh/LMDZS/netcdf-4.0.1/include -fdefault-real-8
+%PROD_FFLAGS         -O3 
+%DEV_FFLAGS          -p -g -O 
+%DEBUG_FFLAGS        -p -g  -fbacktrace -fbounds-check
+%MPI_FFLAGS
+%OMP_FFLAGS          -fopenmp
+%BASE_LD             -p  -L/home/sarvesh/LMDZS/netcdf-4.0.1/lib  -lnetcdf  -lblas -llapack
+%MPI_LD             
+%OMP_LD              -fopenmp
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skdmpi.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skdmpi.path	(revision 221)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/arch/arch-x86_skdmpi.path	(revision 221)
@@ -0,0 +1,9 @@
+#NETCDF_LIBDIR='/usr/lib -lnetcdf'
+#NETCDF_INCDIR='/usr/include'
+NETCDF_LIBDIR="-L /home/sarvesh/LMDZS/netcdf-4.0.1/lib"
+NETCDF_INCDIR="-I /home/sarvesh/LMDZS/netcdf-4.0.1/include"
+NETCDF_LIB="-lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""